//############################################################################
// ~ International Laser Display Association ~
// ~     ILDA File Format Driver in C++      ~
// ~             Built for EZFB              ~
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#include "ez_ilda.hpp"

//############################################################################
ez_ilda::ez_ilda()
       : ez_ilda_frame_set()
       , ez_palette_set   ()  
{
}

//############################################################################
ez_ilda::~ez_ilda()
{
}

//############################################################################
void ez_ilda::sync_rgb_and_palette()
{
    int             i                         = 0          ,
                    j                                      ,
                    super_palette_first_frame = 0          ,
                    super_palette_last_frame  = 0          ,
                    current_frame_index       = frame_index;
    ez_palette_set  reduced_palette_set                    ;
    ez_palette      super_palette                          ;
    char            super_palette_name[7]                  ;
    static int      super_palette_number      = 0          ;
    //--------------------------------------------------------------------
    for(j = 0; j < number_of_frames(); j++)
        frame(j).sync_rgb_and_palette();
    //--------------------------------------------------------------------
    while(i < number_of_frames())
    {
        if(frame_picker(i).palette_index != EZ_TRUE_COLOR)
        {
            //------------------------------------------------------------
            super_palette_first_frame = i;
            super_palette = palette_picker(frame_picker(i).palette_index);
            sprintf(super_palette_name, "%06d", super_palette_number);
            super_palette.name = string("SP") + super_palette_name;
            super_palette_number++;
            //------------------------------------------------------------
            while(    i < number_of_frames()
                   && super_palette.unite(palette_picker(frame_picker(i).palette_index))
                 )
            i++;
            //------------------------------------------------------------
            reduced_palette_set.push_back(super_palette);
            super_palette_last_frame  = i - 1;
            //------------------------------------------------------------
            for(j = super_palette_first_frame; j <= super_palette_last_frame; j++)
            {
                frame(j).find_rgb_in_palette(super_palette);
                frame(j).palette_index = reduced_palette_set.number_of_palettes() - 1;
            }
            //------------------------------------------------------------
        }
        else
            i++;
    }
    //--------------------------------------------------------------------
    frame(current_frame_index);
    replace_palette_set(reduced_palette_set);
    palette_index = current_frame().palette_index;
    return;
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
